package calendarapp.plugins;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import calendarapp.utils.FileScanner;

public class PluginLoader {
	// TODO E3: Change this path to wherever your exported plugins are located.
	public static final String pluginPath = "/home/adamw/plugins/";

	/*
	 * This method loads classes found in a given plugin directory using a plugin loader.
	 * The method then filters out those classes and only returns classes with
	 * annotationType.
	 *
	 * @return The returned list of classes sorted according to the given comparator.
	 */
	@SuppressWarnings("unchecked")
	private static List<Class<?>> getPluginClasses(Class annotationType, Comparator comparator) {
		List<File> files = FileScanner.getFiles(new File(pluginPath));
		PluginClassLoader pluginLoader = new PluginClassLoader();
		List<Class<?>>  classList = new ArrayList<Class<?>>();

		// TODO E1: You should construct a for loop here and do the following:
		// Loop through the files opened above and strip the .class suffix
		// from the file name.
		// Using this stripped file name, call pluginLoader.loadClass(strippedName).
		// Add the opened class to classList ONLY IF the class has an annotation
		// of type annotationType attached to it. If you get the last part wrong,
		// you will get type errors later.
		//
		// TIP: You can use Class.getAnnotation(annotationType) to get an
		// annotation of a given type.

		Collections.sort(classList, comparator);

		return classList;
	}

	/*
	 * This method filters a list of classes and only adds them to the pluginList if
	 * they are a valid instance of the Pluggable<?> interface.
	 *
	 * @return List of classes being a valid instance of Pluggable<?>.
	 */
	private static List<Pluggable<?>> getPluginsFromPluginClasses(List<Class<?>> classList) {
		List<Pluggable<?>> pluginList = new ArrayList<Pluggable<?>>();

		// TODO E2: You should construct a for loop here and do the following:
		// Loop through classList and create a new object instance based on that class.
		// Add that object to pluginList ONLY IF it is a valid instance of
		// the Pluggable<?> interface.
		//
		// TIP: Class.newInstance() can be used to create new instances of the classes
		// in classList.

		return pluginList;
	}

	public static List<Pluggable<?>> loadCalendarPlugins() {
		List<Class<?>> pluginClasses = getPluginClasses(CalendarPlugin.class, new CalendarPluginSorter());
		List<Pluggable<?>> plugins = getPluginsFromPluginClasses(pluginClasses);

		return plugins;
	}

	public static List<Pluggable<?>> loadGUIPlugins() {
		List<Class<?>> pluginClasses = getPluginClasses(GUIPlugin.class, new GUIPluginSorter());
		List<Pluggable<?>> plugins = getPluginsFromPluginClasses(pluginClasses);

		return plugins;
	}
}
