package edu.chl.hajo.monopoly.core;

import java.util.Random;

/**
 * A general dice
 *
 * @author hajo
 *
 */
public class Dice {

    private static final int DEFAULT_FACES = 6;
    private static final Random rand = new Random();
    private final int nFaces;
    private int lastResult;

    public Dice(int nFaces) {
        this.nFaces = nFaces;
    }

    public Dice() {
        this.nFaces = DEFAULT_FACES;
    }

    public int roll() {
        lastResult = rand.nextInt(nFaces) + 1;
        return lastResult;
    }

    public int getLastResult() {
        if (lastResult == 0) {
            throw new IllegalStateException("Must throw dice, no last result yet");
        }
        return lastResult;
    }
}
