package edu.chl.hajo.monopoly.core;

import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author hajo
 */
public class TestPlayer {
    
    @Test
    public void testPlayerWithDrawAndIncome() { 
        // No need for fixture right now ...
        Player p = new Player("olle", Piece.CAR, 1000);  // Balance = 1000
        
        assertTrue(p.withDraw(500));
        assertFalse(p.withDraw(600));
        
        p.income(100);
        assertTrue(p.withDraw(600));
        
        assertTrue(p.getBalance() == 0);
    }
    
    @Test
    public void testPlayerPayDebt() {        
        Player p1 = new Player("olle", Piece.CAR, 1000);        
        Player p2 = new Player("fia", Piece.DOG, 1000);        
      
        Debt d = new Debt(p2, 600);       
        p1.addDebt(d);
        assertTrue(p1.hasDebt());
        
        p1.payDebt();
        
        assertTrue(p1.getBalance() == 400);
        assertTrue(p2.getBalance() == 1600);
        
        assertFalse(p1.hasDebt());
        
        p1.addDebt(d);
        p1.payDebt();
        assertTrue(p1.hasDebt());
        
    }    
    
}
