package edu.chl.hajo.monopoly.gui;

import edu.chl.hajo.monopoly.core.DicePair;
import edu.chl.hajo.monopoly.core.IMonopoly;
import edu.chl.hajo.monopoly.core.MonopolyOptions;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.event.IEventHandler;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * Panel for buttons: Roll, Next , etc
 * @author hajo
 */
public class ButtonPanel extends JPanel implements IEventHandler, ActionListener {

    private final JButton roll = new JButton("Roll");
    private final JButton next = new JButton("Next");
    private final JLabel diceResult = new JLabel(":");
    private IMonopoly m;

    public ButtonPanel() {
        this.setLayout(new GridLayout(1, MonopolyOptions.getNPlayers()));
        roll.addActionListener(this);
        next.addActionListener(this);
        this.add(roll);
        this.add(next);
        this.add(diceResult);
        roll.setEnabled(false);
        next.setEnabled(false);
        EventBus.INSTANCE.register(this);
        this.setSize(400, 100);
    }

    @Override
    public void onEvent(Event evt) {
        switch (evt.getTag()) {
            case NEW_GAME:
                m = (IMonopoly) evt.getValue();
                roll.setEnabled(true);
                break;
            case DICE_RESULT:
                DicePair dp =  (DicePair) evt.getValue();
                String result = dp.getFirst() + ":" + dp.getSecond();
                diceResult.setText(result);
                roll.setEnabled(dp.bothAre(6));
                next.setEnabled(true);
                break;
             case NEXT:  
                 Player actual = (Player) evt.getValue();
                 roll.setEnabled(true);
                 next.setEnabled(false);
                 
                break;
            default: ;
        }

    }

    @Override
    public void actionPerformed(ActionEvent e) {
        if (e.getSource() == roll) {
            m.move();
        } else if (e.getSource() == next) {
            m.next();
        }
    }
    
    private void setButtons(){
        
    }

}
