package edu.chl.hajo.monopoly.core;

import java.util.ArrayList;
import java.util.List;

import edu.chl.hajo.monopoly.constants.Constants;
import edu.chl.hajo.monopoly.core.space.NonProperty;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.AbstractSpace;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.io.FileReader;

/**
 * @author hajo
 * 
 */
public final class Board {
	
	private List<AbstractSpace> spaces = new ArrayList<AbstractSpace>();

	public Board() {
		List<String> strs = FileReader.getInstance()
				.readDataFile(Constants.SPACES_DATA_FILE);
		for (String s : strs) {
			if (s.matches("street.*")) {
				spaces.add(new Street(s));
			} else if (s.matches("(train|energy|water)")) {
				spaces.add(new Property(s));
			} else if (s.matches("(chance|go|jail|gojail|park|community)")) {
				spaces.add(new NonProperty(s));
			} else if (s.equals("tax")) {
				spaces.add(new Tax(s));
			}
		}
	}

	public List<AbstractSpace> getSpaces() {
		return spaces;
	}

}
