package edu.chl.hajo.monopoly.core;

import java.util.Collections;
import java.util.List;

import edu.chl.hajo.monopoly.core.space.AbstractSpace;

/**
 * The board
 * @author hajo
 *
 */
public class Board2 {
	protected List<AbstractSpace> spaces;
	
	public Board2(List<AbstractSpace> spaces) {
		this.spaces = spaces;
	}

	public List<AbstractSpace> getSpaces() {
		return Collections.unmodifiableList(spaces);
	}

	public void put(Player p) {
		int i = p.getPosition();
		spaces.get(i).addVisitingPlayer(p);
	}

	public void remove(Player p) {
		int i = p.getPosition();
		spaces.get(i).removeVisitingPlayer(p);
	}

	public int getSize() {
		return spaces.size();
	}
}
