package edu.chl.hajo.monopoly.core.space;

import edu.chl.hajo.monopoly.core.IDialogVisitor;
import edu.chl.hajo.monopoly.core.IPanelVisitor;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.event.GameEvents;
import edu.chl.hajo.monopoly.util.Config;

/**
 * A space which can't be owned but where you have to pay
 * @author hajo
 *
 */
public class Tax extends NonProperty {

	private final int tax = Config.getTax();

	public Tax(String name) {
		super(name);
	}

	@Override
	public void checkEvent(Player player) {
		eb.broadcast(GameEvents.MUST_PAY_TAX,null, this);
	}
	
	@Override
	public void visit(IPanelVisitor pf) {
		pf.setPanel(this);
		
	}
	@Override
	public void visit(IDialogVisitor df) {
		df.setDialog(this);
		
	}

	public int getTax() {
		return tax;
	}
}
