package edu.chl.hajo.monopoly.view.details;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JButton;
import javax.swing.WindowConstants;

import edu.chl.hajo.monopoly.core.IPlayer;
import edu.chl.hajo.monopoly.core.Locator;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.event.StateChanges;
import edu.chl.hajo.monopoly.view.PropertyPanel;
/**
 * Detailed view of Property (can buy/sell)
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class PropertyDetails extends AbstractSpaceDetails implements
		PropertyChangeListener {

	private JButton jBtnSell;
	private JButton jBtnBuy;

	private Property property;

	public PropertyDetails(PropertyPanel parent, Property property) {
		super(parent, property);
		this.property = property;
		eb.connect(this, property);
		initGUI();
		initControls();
	}

	@Override
	protected void onOpen() {
		setButtons();
	}

	private void setButtons() {
		IPlayer p = Locator.getGame().getPlayer();
		jBtnBuy.setEnabled(Locator.getGame().getRules().buyEnabled(property, p));
		jBtnSell.setEnabled(Locator.getGame().getRules().sellPropertyEnabled(property,p));
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		String e = evt.getPropertyName();

		boolean b = e.equals(StateChanges.PROPERTY_GOT_OWNER.toString())
				|| e.equals(StateChanges.PROPERTY_LOST_OWNER.toString());
		if (b) {
			setButtons();
		}
	}

	private void initControls() {
		jBtnBuy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				Locator.getGame().getPlayer().buyProperty(property);
			}
		});
		jBtnSell.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				Locator.getGame().getPlayer().sellProperty(property);
			}
		});
	}

	private void initGUI() {
		try {
			{
				FlowLayout thisLayout = new FlowLayout();
				getContentPane().setLayout(thisLayout);
				this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
				{
					jBtnBuy = new JButton();
					getContentPane().add(jBtnBuy);
					jBtnBuy.setText("JBtnBuy");
				}
				{
					jBtnSell = new JButton();
					getContentPane().add(jBtnSell);
					jBtnSell.setText("jBtnSell");
					jBtnSell.setEnabled(false);
				}
			}
			{
				this.setSize(287, 261);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
