package edu.chl.hajo.monopoly.view.dialog;

import javax.swing.JFrame;

import edu.chl.hajo.monopoly.core.Locator;
import edu.chl.hajo.monopoly.core.space.NonProperty;

/**
 * Event dialog for NonProperty fired events
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class NonPropertyEventDialog extends AbstractEventDialog {

	private NonProperty np;

	public NonPropertyEventDialog(JFrame parent, NonProperty np) {
		super(parent);
		this.np = np;
		if (np.getName().equals("community")) {
			jLblText.setText("community");
		} else if (np.getName().equals("chance")) {
			jLblText.setText("chance");
		} else if (np.getName().equals("gojail")) {
			jLblText.setText("gojail");
		}
	}

	@Override
	protected void execute() {
		if (np.getName().matches("community|chance")) {
			Locator.getGame().chanceCommunity();
		} else if (np.getName().equals("gojail")) {
			Locator.getGame().getPlayer().goToJail();	
		}
		this.dispose();
	}

}
