package edu.chl.hajo.monopoly.core.space;

import edu.chl.hajo.monopoly.constants.GameEvents;
import edu.chl.hajo.monopoly.core.IDialogVisitor;
import edu.chl.hajo.monopoly.core.IPanelVisitor;
import edu.chl.hajo.monopoly.core.Player;

/**
 * A space that can't be owned.
 * 
 * chance|go|jail|gojail|park|community
 * 
 * @author hajo
 * 
 */
public class NonProperty extends AbstractSpace {
	
	public NonProperty(String name) {
		super(name);		
	}

	/*
	 * Could have used classes instead of if's
	 */
	@Override
	public void checkEvent(Player p) {
		if (name.equals("chance")) {
			eb.broadcast(GameEvents.CHANCE, null,this);
		} else if (name.equals("gojail")) {		
			eb.broadcast(GameEvents.GO_JAIL, null,this);
		} else if (name.equals("community")) {
			eb.broadcast(GameEvents.COMMUNITY, null,this);		
		}
	}

	@Override
	public void visit(IPanelVisitor pf) {
		pf.setPanel(this);
	}

	@Override
	public void visit(IDialogVisitor df) {
		df.setDialog(this);
	}
}
