package edu.chl.hajo.monopoly.core.space;

import java.util.ArrayList;
import java.util.List;

import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.Building;
import edu.chl.hajo.monopoly.core.IDetailsVisitor;
import edu.chl.hajo.monopoly.core.IDialogVisitor;
import edu.chl.hajo.monopoly.core.IPanelVisitor;

/**
 * A space that has owner and possible buildings
 * @author hajo
 *
 */

public class Street extends Property {
	// TODO Seems unnecessary (a single int with for number
	// of building would suffice? )
	private final List<Building> buildings = new ArrayList<Building>(); 
	
	public Street(String name){
		super(name);
	}

	@Override
	public void visit(IPanelVisitor pf) {
		pf.setPanel(this);
		
	}
	@Override
	public void visit(IDialogVisitor df) {
		df.setDialog(this);	
	}
	
	@Override
	public void visit( IDetailsVisitor df ){
		df.setDetails(this);
	}

	public void addBuilding(Building b) {
		buildings.add(b);
		eb.send(this, StateChanges.STREET_ADD_BUILDING, null, buildings);
	}
	public Building removeBuilding() {
		Building b = null;
		if( buildings.size() > 0){
			b = buildings.remove(buildings.size()-1);
		}
		eb.send(this, StateChanges.STREET_REMOVE_BUILDING, null, buildings);
		return b;
	}
	
	public int getNrOfBuildings() {
		return buildings.size();
	}
	
	@Override
	public int getRent(){
		return 200 * buildings.size() + rent; 
	}
}
