package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Building;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.rules.Rules;
import edu.chl.hajo.monopoly.util.Config;
/**
 * Control
 * @author hajo
 *
 */
class SellBuildingCtrl extends AbstractControl{

	private Street street;

	public SellBuildingCtrl(Street street) {
		this.street = street;
	}

	public void execute() {
		
		if( !Rules.sellBuildingEnabled(street)){
			return;
		}
		
		Player p = g.getActualPlayer();
		Building b = street.removeBuilding();
		if (b != null) {
			// Bank pays half
			p.addIncome(b.getPrice() / Config.getResellPriceReduction());
		}
	}
}
