package edu.chl.hajo.monopoly.view;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JTextField;

import edu.chl.hajo.monopoly.constants.GameEvents;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.ctrl.CF;

/**
 * Class holding the main button to throw dices and end round
 * @author hajo
 * 
 * NOTE: Static GUI already connected to EventBus
 *
 */
@SuppressWarnings("serial")
public class ControlPanel extends JPanel implements PropertyChangeListener {
	private JButton jBtnNext;
	private JButton jBtnThrowDice;
	// Debug
	private JTextField jTxtFldSteps;

	public ControlPanel() {
		initGUI();
		initCtrls();
	}

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		String name = evt.getPropertyName();
		if( name.equals(StateChanges.GAME_NEW_ACTUAL_PLAYER.toString())){
			jBtnThrowDice.setEnabled(true);
			jBtnNext.setEnabled(false);
		} else if( name.equals(GameEvents.GO_JAIL.toString())){
			jBtnThrowDice.setEnabled(false);
			jBtnNext.setEnabled(true);		
		}else if( name.equals(GameEvents.DICES_EQUAL.toString())){
			jBtnThrowDice.setEnabled(true);
			jBtnNext.setEnabled(false);
		}
	}
	
	private void initCtrls() {
		jBtnNext.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				CF.get(CF.Name.END_TURN).execute();
			}
		});
		jBtnThrowDice.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				String nMoves = jTxtFldSteps.getText();
				jTxtFldSteps.setText("");
				// Order matters, before m.execute();
				jBtnThrowDice.setEnabled(false);
				jBtnNext.setEnabled(true);
				// Debug (something written in field)
				if (nMoves.length() > 0) {
					CF.get(CF.Name.MOVE, Integer.parseInt(nMoves)).execute();
				} else {
					CF.get(CF.Name.MOVE).execute();
				}
			}
		});
	}

	private void initGUI() {
		this.setBackground(Color.LIGHT_GRAY);
		{
			jTxtFldSteps = new JTextField();
			jTxtFldSteps.setColumns(4);
			this.add(jTxtFldSteps);
		}

		{
			jBtnThrowDice = new JButton();
			jBtnThrowDice.setLayout(null);
			jBtnThrowDice.setText("jBtnThrowDice");
			jBtnThrowDice.setEnabled(true);
			this.add(jBtnThrowDice);
		}
		{
			jBtnNext = new JButton();
			jBtnNext.setText("jBtnNext");
			jBtnNext.setEnabled(false);
			this.add(jBtnNext);
		}
	}

	
}
