package edu.chl.hajo.monopoly.view.details;

import java.awt.event.WindowEvent;
import java.awt.event.WindowAdapter;

import javax.swing.JDialog;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly.core.space.AbstractSpace;
import edu.chl.hajo.monopoly.event.EventBus;

/**
 * base class for all details
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public abstract class AbstractSpaceDetails extends JDialog {
	
	protected EventBus eb = EventBus.getInstance();
	
	public AbstractSpaceDetails(JPanel parent, AbstractSpace space) {
		this.setLocationRelativeTo(parent);
		this.setModalityType(ModalityType.APPLICATION_MODAL);
		this.setTitle(space.getName());
		this.addWindowListener(new WindowAdapter() {
			
			@Override
			public void windowOpened(WindowEvent e) {
				onOpen();
				
			}
		});
	}
	
	
	protected abstract void onOpen();	
}
