package edu.chl.hajo.monopoly.core;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * A command line test bench for the first
 * design model
 *
 * @author hajo
 *
 */
public class CommandLineMonopoly {

    public static void main(String[] args) {
        boolean done = false;
        Scanner sc = new Scanner(System.in);

        Monopoly m = MonopolyFactory.getMonopoly();
        System.out.println(m.getActual());
        dumpGame(m);
        System.out.println("(m)ove, (n)ext, (q)uit");
        while (!done) {
            System.out.print("> ");
            String cmd = sc.nextLine();
            switch (cmd) {
                case "q":
                    done = true;
                    break;
                case "m":
                    m.move();
                    System.out.println(m.getDicePair().getFirst() + ":"
                            + m.getDicePair().getSecond());
                    Player p = m.getActual();
                    if (p.isBroke()) {
                        // Game over for this one
                    }
                    

                    break;
                case "n":
                    m.next();
                    break;
                default: ;

            }
            dumpGame(m);
        }
        System.out.println("Game over");
    }

    private static void dumpGame(Monopoly m) {
        Board b = m.getBoard();
        for (Space s : b) {
            System.out.print("[ " + s + "]");
            for (Player p : m.getPlayers()) {
                if (s == p.getPosition()) {
                    if (p == m.getActual()) {
                        System.out.print("*" + p);
                    } else {
                        System.out.print(p);
                    }
                }
            }
            System.out.println();
        }
        System.out.println();
    }
    
    
  
}
