package edu.chl.hajo.mply.core;

/**
 * This is the very special P model class
 * Class holds all parameterization data for the model
 * (no hard coded values in model classes)
 * 
 * (Other solution is to pass in the data to every class in need
 * but that would require method's or pass via constructor, this is simpler.
 * The short name is just to: Save some typing, and also, this is not a concept
 * of it's own)
 * 
 * @author hajo
 *
 */


public enum P {
    INSTANCE;
    
    public int getMaxSpaces(){
        return 8;
    }
    public int getMaxPlayers(){
        return 2;
    }
    public int getPassGoIncome() {
        return 4000;
    }  
    public int getMaxDice(){
        return 4;
    }
    
}
