package edu.chl.hajo.mply.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.mply.core.Monopoly;
import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;
import edu.chl.hajo.mply.event.EventHandler;

/**
 * Panel to handle roll and display of dice.
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class DicePanel extends JPanel implements ActionListener, EventHandler {

    private JLabel result = new JLabel("00");
    private JButton roll = new JButton("roll");
    
    public DicePanel() {
        init();
        EventBus.register(this);
    }

    @Override
    public void actionPerformed(ActionEvent e) {
        Monopoly.INSTANCE.move();
    }

    @Override
    public void onEvent(Event evt) {
        if( evt.getTag().equals(Event.Tag.DICE_VALUE)){
            int i = (Integer) evt.getValue();
            result.setText(String.valueOf(i));
        }else if( evt.getTag().equals(Event.Tag.PIECE_MOVABLE)){
            boolean b = (Boolean) evt.getValue();
            roll.setEnabled(b);
        }  
    }

    private void init(){
        roll.addActionListener(this);
        this.add(roll);
        this.add(result);
       
    }
}
