package edu.chl.hajo.mply.gui;

import java.awt.BorderLayout;

import javax.swing.JFrame;
import javax.swing.JPanel;

import edu.chl.hajo.mply.core.Card;
import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;
import edu.chl.hajo.mply.event.EventHandler;

/**
 * Application main window, composed of all the panels.
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class MainFrame extends JFrame implements EventHandler {
   

    private DicePanel dicePanel = new DicePanel();
    private ControlPanel controlPanel = new ControlPanel();
    private SpaceContainerPanel spaceContainerPanel = new SpaceContainerPanel();
    private PlayerContainerPanel playerContainerPanel = new PlayerContainerPanel();
    
   
    public MainFrame() {
        init();
        EventBus.register(this);
    }

    private void init() {
        setDefaultCloseOperation(EXIT_ON_CLOSE);
        setTitle("Monopoly");
        setSize(400, 400);
        setLayout(new BorderLayout());
        getContentPane().add(playerContainerPanel, BorderLayout.NORTH);
        getContentPane().add(spaceContainerPanel, BorderLayout.CENTER);
        JPanel south = new JPanel();
        south.add(dicePanel);
        south.add(controlPanel);
        getContentPane().add(south, BorderLayout.SOUTH); 
    }

    @Override
    public void onEvent(Event evt) {
        if( evt.getTag().equals(Event.Tag.CARD)){
            Card c = (Card) evt.getValue();
            CardDialog cd = new CardDialog(c);
            cd.setLocationRelativeTo(this);
            cd.setVisible(true);
        }
    }
}
