package edu.chl.hajo.monopoly03.view;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.Collection;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly03.ctrl.EndTurnCtrl;
import edu.chl.hajo.monopoly03.ctrl.MoveCtrl;
import edu.chl.hajo.monopoly03.ctrl.StartCtrl;
import edu.chl.hajo.monopoly03.model.Monopoly03;
import edu.chl.hajo.monopoly03.model.Player;
import edu.chl.hajo.monopoly03.model.Space;



/**
 * This is bad structure just use for now (refactor to real MVC)
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class MainFrame extends JFrame {

    private Monopoly03 mp;
    JPanel players;
    JPanel spaces;
    JPanel buttons;

    public MainFrame(Monopoly03 mp) {
        this.mp = mp;

        this.setTitle("Monopoly");
        this.setLocationRelativeTo(null);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);
        this.setLayout(new BorderLayout());
        Collection<Player> pls = mp.getPlayers();
        players = getPlayersPanel(pls);
        this.add(players, BorderLayout.NORTH);
        Collection<Space> sps = mp.getBoard().getSpaces();
        spaces = getSpacesPanel(sps);
        buttons = getButtonsPanel();
        this.add(spaces, BorderLayout.CENTER);
        this.add(buttons, BorderLayout.SOUTH);
        this.setSize(500, 300);
    }

    private JPanel getPlayersPanel(Collection<Player> pls) {
        JPanel players = new JPanel();
        players.setLayout(new GridLayout(1, pls.size()));
        for (Player p : pls) {
            players.add(new PlayerPanel(p.getName()));
        }
        return players;
    }

    private JPanel getSpacesPanel(Collection<Space> sps) {
        JPanel spaces = new JPanel();
        spaces.setLayout(new GridLayout(1, sps.size()));
        for (Space s : sps) {
            spaces.add(new SpacePanel(s.getName()));
        }
        return spaces;
    }

    private JPanel getButtonsPanel() {
        JPanel buttons = new JPanel();
        JButton start = new JButton("Start"); 
        JButton move = new JButton("Move");    
        JButton endTurn = new JButton("End Turn");
        buttons.add(start);
        buttons.add(move);
        buttons.add(endTurn);
        
        JLabel diceResult = new JLabel("0:0");
        buttons.add(diceResult);
        
        // Listeners/Controls
        StartCtrl sctrl = new StartCtrl(mp);
        sctrl.putValue("spaces", spaces);
        sctrl.putValue("start", start);
        start.addActionListener(sctrl);
        MoveCtrl mctrl = new MoveCtrl(mp);
        mctrl.putValue("spaces", spaces);
        mctrl.putValue("diceResult", diceResult);
        move.addActionListener(mctrl);
        EndTurnCtrl ectrl = new EndTurnCtrl(mp);
        endTurn.addActionListener(ectrl);
        
        return buttons;
    }

}
