package edu.chl.hajo.monopoly03;

import static org.junit.Assert.assertTrue;

import java.util.ArrayList;
import java.util.List;

import org.junit.Before;
import org.junit.Test;

import edu.chl.hajo.monopoly03.model.Board;
import edu.chl.hajo.monopoly03.model.Deck;
import edu.chl.hajo.monopoly03.model.Dice;
import edu.chl.hajo.monopoly03.model.IBoard;
import edu.chl.hajo.monopoly03.model.Monopoly03;
import edu.chl.hajo.monopoly03.model.Piece;
import edu.chl.hajo.monopoly03.model.Player;
import edu.chl.hajo.monopoly03.model.Space;



/**
 * NOTE this is no real unit testing it's a  simple
 * way to run the model
 * @author hajo
 *
 */
public class TestMonopoly03 {

    Monopoly03 mp;

    @Before
    public void before() {
        Player p1 = new Player("A", Piece.CAR, 0);
        Player p2 = new Player("B", Piece.DOG, 0);
        Player p3 = new Player("C", Piece.IRON, 0); // Use as owner
        List<Player> players = new ArrayList<>();
        players.add(p1);
        players.add(p2);
        Dice dice = new Dice(2);
        List<Space> spaces = new ArrayList<>();
        for (int i = 0; i < 10; i++) {
            if (i % 2 == 0) {
                // Add a card space
                spaces.add(new Space(String.valueOf(i), 500, true));
            } else {
                // Normal space
                spaces.add(new Space(String.valueOf(i), 500, false));
            }
        }
        spaces.get(0).addVisitor(p1);
        spaces.get(0).addVisitor(p2);
        // Owner!
        spaces.get(2).setOwner(p3);
        Board board = new Board(spaces);
        Deck deck = new Deck();

        mp = new Monopoly03(dice, board, players, deck);
    }

    //@Test
    public void testOnePlayerMakesAMove() {
        mp.move();
        System.out.println(mp);
        assertTrue(true);
    }

    //@Test
    public void testOnePlayerMakesAMoveHasToPayRent() {
        mp.move(2);
        System.out.println(mp);
        assertTrue(true);
    }
     // Same as above but extracting state from model (to put in GUI)
    @Test
    public void testOnePlayerMakesAMoveHasToPayRent2() {
        mp.move(2);
        Dice d = mp.getDice();
        IBoard b = mp.getBoard();
        System.out.println(d.getFirst() + ":" + d.getSecond());
        for( Space s : b.getSpaces()){
            // Possible to get all data but uses toString for now
            System.out.print(s.toString());
        }
        assertTrue(true);
    }

   
}
