package edu.chl.hajo.monopoly04.io;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

/**
 * Use generic's to reduce dependencies (else dependency on model)
 * Class to convert to must have constructor with String[] parameter
 * @author hajo
 *
 */
public class GenericConverter<T> {

    private Class<? extends T> clazz;

    public GenericConverter(Class<? extends T> clazz) {
        this.clazz = clazz;
    }

    public final static String ITEM_SEPARATOR = ",";

    public T toObject(String objectAsString) {
        String[] items = objectAsString.split(ITEM_SEPARATOR);
        T t = null;
        try {
            Constructor<? extends T> ctor = clazz
                    .getConstructor(String[].class);
            t = ctor.newInstance(new Object[]{items});
        } catch (InstantiationException | IllegalAccessException
                | NoSuchMethodException | SecurityException
                | IllegalArgumentException | InvocationTargetException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        return t;
    }

}
