package edu.chl.hajo.monopoly04.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collection;
import java.util.HashSet;
import java.util.Random;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly04.dialogs.BuySellDialog;
import edu.chl.hajo.monopoly04.eventbus.Event;
import edu.chl.hajo.monopoly04.eventbus.IEventHandler;
import edu.chl.hajo.monopoly04.model.Player;
import edu.chl.hajo.monopoly04.model.Space;

/**
 * View of single Space
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class SpacePanel extends JPanel implements IEventHandler {

    private final String spaceName;
    private JPanel visitorPanel;

    public SpacePanel(String name) {
        this.spaceName = name;
        init();
    }

    private void init() {
        this.setLayout(new BorderLayout());
        JPanel namePanel = new JPanel();
        namePanel.setBackground(Color.LIGHT_GRAY);
        namePanel.add(new JLabel(spaceName));
        this.add(namePanel, BorderLayout.NORTH);
        visitorPanel = new JPanel();
        this.add(visitorPanel, BorderLayout.CENTER);
        this.setBorder(BorderFactory.createLineBorder(Color.black));
    }
    
    MouseAdapter mouseAdapter = new MouseAdapter() {
        public void mouseClicked(MouseEvent e) {
            new BuySellDialog().setVisible(true);
         }
     };
    
    
    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.UPDATE_SPACE) {
            Space space = (Space) evt.getValue();
            String s = space.getName();
            if (s.equals(spaceName)) {
                visitorPanel.removeAll();
                for (Player p : space.getVisitors()) {
                    visitorPanel.add(new JLabel(p.getPiece().toString()));
                }
                // Must have both  "?!xx@#¤%!!!!!!
                visitorPanel.repaint();
                validate();
            }
        }else if(evt.getTag() == Event.Tag.START) {
            this.addMouseListener(mouseAdapter);
        }
    }
}
