package odemo;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

public class ModelClass implements IObservable {
	
	// Handling the list of observers, see also monopoly examples
	PropertyChangeSupport observers = new PropertyChangeSupport(this);

	private int i = 0;
	public void doIt(){
		i++;
		// Notify all observers (calls method PropertyChange in observer)
		// Params: Name of event, oldValue, newValue
		observers.firePropertyChange(StateChanges.A_CHANGE.toString(), null, i);
	}
	
	
	@Override
	public void addObserver(PropertyChangeListener observer) {
		// Just a wrapper method 
		observers.addPropertyChangeListener(observer);
		
	}

}
